require 'pipeline/tasks/base_task'
require 'pipeline/util'

class Pipeline::Test < Pipeline::BaseTask
  Pipeline::Tasks.add self
  include Pipeline::Util

  def initialize(trigger, tracker)
    super(trigger, tracker)
    @name = "Test"
    @description = "Test"
    @stage = :code
    @labels << "code" << "ruby"
  end

  def run
    # Pipeline.notify "#{@name}"
    rootpath = @trigger.path
    Pipeline.debug "Rootpath: #{rootpath}"
    Dir.chdir("#{rootpath}") do
      @result= runsystem(true, "grep", "-R", "secret")
    end
  end

  def analyze
    begin
      list = @result.split(/\n/)
      list.each do |match|
          report "Match", match, @name, :low, "fingerprint"
      end
  rescue Exception => e
      Pipeline.warn e.message
      Pipeline.notify "Error grepping ... "
    end
  end

  def supported?
    supported=runsystem(true, "grep", "-h")
    if supported =~ /usage/
      Pipeline.notify "Install grep."
      return false
    else
      return true
    end
  end

end
